//+------------------------------------------------------------------+
//|                                                  WeeklyPivot.mq4 |
//|  I found the original indicator in TSD forum posted by heliyaun. |
//|                                       I dont know how wrote it. |
//| I like it because have mondays fixed for broker with GMT outside |
//| london time.                                                     |
//| So, I added some stuff, labels, fix, etc. and them, I wrote the|
//|             Medians SR, and then, I wrote the same for Monthlies |
//|                                                                  |
//|                                                           Enjoy. |
//|                                                                  |
//|                                           Linuxser, January 2007 |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Salmon
#property indicator_color2 MediumOrchid
#property indicator_color3 HotPink
#property indicator_color4 MediumPurple
#property indicator_color5 Violet
#property indicator_color6 Orchid

//---- input parameters

extern color     LabelColor=LightSalmon;
extern int       fontsize=9;
extern int       LabelShift = 0;

//---- buffers
double MM0Buffer[];
double MM1Buffer[];
double MM2Buffer[];
double MM3Buffer[];
double MM4Buffer[];
double MM5Buffer[];
string Pivot="MonthlyPivotPoint",Sup1="MM0", Res1="MM";
string Sup2="MM2", Res2="MM3", Sup3="MM4", Res3="MM5";
double MP,MM0,MM1,MM2,MM3,MM4,MM5;
double last_month_high, last_month_low, this_month_open, last_month_close;
datetime LabelShiftTime;
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here

   ObjectDelete("MM0");
   ObjectDelete("MM1");
   ObjectDelete("MM2");
   ObjectDelete("MM3");
   ObjectDelete("MM4");
   ObjectDelete("MM5");
   ObjectDelete("MM6");   

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;


//---- indicator line
   SetIndexStyle(0,DRAW_LINE,EMPTY);
   SetIndexStyle(1,DRAW_LINE,EMPTY);
   SetIndexStyle(2,DRAW_LINE,EMPTY);
   SetIndexStyle(3,DRAW_LINE,EMPTY);
   SetIndexStyle(4,DRAW_LINE,EMPTY);
   SetIndexStyle(5,DRAW_LINE,EMPTY);
   SetIndexStyle(6,DRAW_LINE,EMPTY);
   SetIndexBuffer(0,MM0Buffer);
   SetIndexBuffer(1,MM1Buffer);
   SetIndexBuffer(2,MM2Buffer);
   SetIndexBuffer(3,MM3Buffer);
   SetIndexBuffer(4,MM4Buffer);
   SetIndexBuffer(5,MM5Buffer);


//---- name for DataWindow and indicator subwindow label
   short_name="Pivot Point Medians Monthly";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);

//----
   SetIndexDrawBegin(0,1);
//----
 

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()

  {
   int counted_bars=IndicatorCounted();

   int limit, i;
//---- indicator calculation
if (counted_bars==0)
{
   if(Period() > 1440)
   {
   Print("Error - Chart period is greater than 1 day.");
   return(-1); // then exit
   }
   
}
   if(counted_bars<0) return(-1);

   limit=(Bars-counted_bars)-1;


for (i=limit; i>=0;i--)
{ 


   // Monday
	if(TimeDay(Time[i])<=3 && TimeDay(Time[i+1])>=26)
	{
		last_month_close = Close[i+1];
		this_month_open = Open[i];

		// monthlyPivot
	MP = (last_month_high + last_month_low + last_month_close) / 3;

   MM0 = (3*last_month_low-2*last_month_high+last_month_close)/2;
   MM1 = (2*last_month_low-last_month_high+last_month_close)/2;
   MM2 = (last_month_low+last_month_close)/2;
   MM3 = (last_month_high+last_month_close)/2;
   MM4 = (2*last_month_high-last_month_low+last_month_close)/2;
   MM5 = (3*last_month_high-2*last_month_low+last_month_close)/2;  

  
   last_month_low=Low[i]; last_month_high=High[i];

   LabelShiftTime = Time[LabelShift];

      ObjectCreate("MM0", OBJ_TEXT, 0, LabelShiftTime, 0);
      ObjectSetText("MM0", "                      Mo M0 " +DoubleToStr(MM0,4),fontsize,"tahoma ",LabelColor);
      SetIndexLabel(0, "MM0");
      ObjectCreate("MM1", OBJ_TEXT, 0, LabelShiftTime, 0);
      ObjectSetText("MM1", "                      Mo M1 " +DoubleToStr(MM1,4),fontsize,"tahoma ",LabelColor);
      SetIndexLabel(1, "MM1");
      ObjectCreate("MM2", OBJ_TEXT, 0, LabelShiftTime, 0);
      ObjectSetText("MM2", "                      Mo M2 " +DoubleToStr(MM2,4),fontsize,"tahoma ",LabelColor);
      SetIndexLabel(2, "MM2");
      ObjectCreate("MM3", OBJ_TEXT, 0, LabelShiftTime, 0);
      ObjectSetText("MM3", "                      Mo M3 " +DoubleToStr(MM3,4),fontsize,"tahoma ",LabelColor);
      SetIndexLabel(3, "MM3");
      ObjectCreate("MM4", OBJ_TEXT, 0, LabelShiftTime, 0);
      ObjectSetText("MM4", "                      Mo M4 " +DoubleToStr(MM4,4),fontsize,"tahoma ",LabelColor);
      SetIndexLabel(4, "MM4");
      ObjectCreate("MM5", OBJ_TEXT, 0, LabelShiftTime, 0);
      ObjectSetText("MM5", "                      Mo M5 " +DoubleToStr(MM5,4),fontsize,"tahoma ",LabelColor);
      SetIndexLabel(5, "MM5");
      Print("ObjectSet Done");
      ObjectMove("MM0", 0, LabelShiftTime,MM0);
      ObjectMove("MM1", 0, LabelShiftTime,MM1);
      ObjectMove("MM2", 0, LabelShiftTime,MM2);
      ObjectMove("MM3", 0, LabelShiftTime,MM3);
      ObjectMove("MM4", 0, LabelShiftTime,MM4);
      ObjectMove("MM5", 0, LabelShiftTime,MM5);

}   
    
    last_month_high = MathMax(last_month_high, High[i]);
 	 last_month_low = MathMin(last_month_low, Low[i]);   
    
    MM0Buffer[i]=MM0;
    MM1Buffer[i]=MM1;
    MM2Buffer[i]=MM2;
    MM3Buffer[i]=MM3;
    MM4Buffer[i]=MM4;
    MM5Buffer[i]=MM5;

}

//----
   return(0);
  }
//+------------------------------------------------------------------+